SystemOrganization addCategory: #'GT-Tools'!
SystemOrganization addCategory: #'GT-Tools-Coder'!
SystemOrganization addCategory: #'GT-Tools-Utils'!
SystemOrganization addCategory: #'GT-Tools-Prototypes'!

GLMGlobalBrowserTemplate subclass: #GTAbstractCoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Coder'!

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:48'!
classReferencesIn: a
	(a list)
		title: 'References';
		useExplicitNotNil;
		when: [ :package :class | class notNil ];
		display: [ :package :class | self systemNavigation allCallsOn: (Smalltalk associationAt: class name) ];
		selectionPopulate: #focusOnMethod
			on: $f
			entitled: 'Jump there'
			with: [ :list | list selection ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:41'!
classSourceIn: a
	(a text)
		forSmalltalk;
		title: 'Class';
		useExplicitNotNil;
		when: [ :package :class :method | class notNil and: [ method isNil ] ];
		display: [ :package :class | class definition ]! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 03:00'!
classesIn: a 
	a list
		title: 'Classes';
		display: [ :package | package classes ];
		icon: [ :each | 
			each theNonMetaClass browserIcon isNil 
				ifFalse: [ OBMorphicIcons iconNamed: each theNonMetaClass browserIcon ]
				ifTrue: [ nil ] ];
		format: [ :each :package |
			(package extendsClass: each)
				ifTrue: [Text string: each name asString attribute: TextColor gray]
				ifFalse: [each name asString] ];
		selectionAct: [:list | list selection inspect] on: $/ entitled: 'Inspect';
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:47'!
detailsIn: a
	self methodSourceCodeIn: a.
	self classSourceIn: a.
	self classReferencesIn: a.
	self sendersIn: a.
	self implementorsIn: a! !

!GTAbstractCoder methodsFor: 'accessing' stamp: 'TudorGirba 1/8/2011 02:57'!
entity
	^ RPackageOrganizer default! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:48'!
implementorsIn: a
	(a list)
		title: 'Implementors';
		display: [ :package :class :method | (self systemNavigation allImplementorsOf: method selector) ];
		selectionPopulate: #focusOnMethod
			on: $f
			entitled: 'Jump there'
			with: [ :list | list selection ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:41'!
methodSourceCodeIn: a
	a text 
		title: 'Method';
		forSmalltalk: [:package :class | class ];
		display: [:package :class :method |
			method getSource ].
! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:41'!
packagesIn: a 
	a list 
		title: 'Packages';
		display: [ :organizer | organizer packages asSortedCollection: [:x :y | x name < y name ] ];
		format: [:each | each name]! !

!GTAbstractCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/8/2011 02:48'!
sendersIn: a
	(a list)
		title: 'Senders';
		display: [ :package :class :method | self systemNavigation allSendersOf: method selector];
		selectionPopulate: #focusOnMethod
			on: $j
			entitled: 'Jump there'
			with: [ :list | list selection ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

GTAbstractCoder subclass: #GTClassicCoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Coder'!

!GTClassicCoder commentStamp: 'TudorGirba 1/8/2011 02:57' prior: 0!
self open
"| browser |
browser := self new browser.
browser openOn: RPackageOrganizer default.
browser inspect"!

!GTClassicCoder classSide methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/1/2010 23:40'!
open
	^ self openOn: RPackageOrganizer default
! !

!GTClassicCoder methodsFor: 'building' stamp: 'TudorGirba 1/8/2011 02:46'!
buildBrowser
	"
	| browser |
	browser := self new browser.
	browser openOn: RPackageOrganizer default.
	browser"
	browser := GLMTabulator new.
	browser 
		row: [:r | r column: #packages; column: #classes; column: #categoriesAndMethods span: 2];
		row: #details.
	browser transmit 
		to: #packages; 
		andShow: [ :a | self packagesIn: a ].
	browser transmit 
		from: #packages; 
		to: #classes; 
		andShow: [ :a | self classesIn: a ].
	browser transmit
		from: #packages;
		to: #categoriesAndMethods port: #package;
		andShow: [:a | self categoriesAndMethodsIn: a ].
	browser transmit from: #classes; to: #categoriesAndMethods.
	browser transmit 
		from: #packages;
		from: #classes;
		from: #categoriesAndMethods port: #selectedMethod;
		to: #details;
		andShow: [:a | self detailsIn: a ].
	^ browser! !

!GTClassicCoder methodsFor: 'building' stamp: 'TudorGirba 1/8/2011 02:46'!
categoriesAndMethodsIn: a
	a custom: (GTClassicCoderInstanceAndMetaCategoriesMethods new browser)! !

!GTClassicCoder methodsFor: 'others' stamp: 'TudorGirba 11/26/2010 09:30'!
classPointOfViewBrowser
	"self new classPointOfViewBrowser openOn: RPackageOrganizer default"
	browser := GLMTabulator new.
	browser column: #packages; column: #classes; column: #definingPackages; column: #methods.
	browser transmit to: #packages; andShow: [ :a |
		a list 
			display: [ :organizer | organizer packages asSortedCollection: [ :x :y | x name < y name ] ];
			format: #name ].
	browser transmit to: #classes; from: #packages; andShow: [ :a | 
		a list
			display: [ :package | package classes ];
			format: [ :each :package |
				(package extendsClass: each)
					ifTrue: [Text string: each name asString attribute: TextColor gray]
					ifFalse: [each name asString] ];
			selectionAct: [:list | list selection inspect] on: $/ entitled: 'Inspect' ].
	browser transmit to: #definingPackages; from: #classes; andShow: [ :a | 
		a list 
			display: [ :class | class packages];
			format: #name ].
	browser transmit to: #methods; from: #definingPackages; from: #classes; andShow: [ :a | 
		a list 
			title: 'Instance';
			display: [ :package :class | package selectorsForClass: class ];
			selectionAct: [:list :package :class | (Array with: package with: class with: list selection) inspect  ] on: $/ entitled: 'Inspect';
			format: [:each :package :class |
				(package includesSelector: each ofClass: class) 
					ifFalse: [Text string: each asString attribute: TextColor gray]
					ifTrue: [each asString] ].
		a list 
			title: 'Meta';
			display: [ :package :class | class theMetaClass selectors ];
			format: [:each :package :class |
				(package includesSelector: each ofClass: class class) 
					ifFalse: [Text string: each asString attribute: TextColor gray]
					ifTrue: [each asString] ] ].
	^ browser! !

GTAbstractCoder subclass: #GTCoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Coder'!

!GTCoder commentStamp: 'TudorGirba 1/11/2011 11:09' prior: 0!
self open!

!GTCoder methodsFor: 'building' stamp: 'TudorGirba 2/4/2011 10:38'!
buildBrowser 
	browser := GLMTabulator new.
	browser
		column: #packages;
		column: #classes;
		column: #details span: 3.
	self defineActions.
	browser transmit to: #packages; andShow: [:a | self packagesIn: a].
	browser transmit from: #packages; to: #classes; andShow: [:a | self classesIn: a].
	browser transmit 
		passivelyFrom: #packages; 
		from: #classes; 
		to: #details; 
		when: [:package :class | class notNil ]; 
		andShowIfNone: [:a | self detailsIn: a ].
	browser transmit fromOutsidePort: #packageToSelect; to: #packages port: #selection.
	browser transmit fromOutsidePort: #classToSelect; to: #classes port: #selection.
	browser transmit 
		toOutsidePort: #packageToSelect; 
		from: #details port: #methodToSelect;
		transformed: [:method | method methodClass package].
	browser transmit 
		toOutsidePort: #classToSelect; 
		from: #details port: #methodToSelect;
		transformed: [:method | method methodClass].
	^ browser! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 22:51'!
defineActions
	browser morphicAct: [:b |
		| selectedClass |
		selectedClass := OBCompletionRequest new
			prompt: 'Find Class';
			searchBlock: [ :string | OBCmdFindClass new findClassIn: Smalltalk pattern: string ];
			labelBlock: [ :class | class name ];
			iconBlock: [ :class | class browserIcon ];
			signal.
		selectedClass notNil ifTrue: [
			(b pane port: #packageToSelect) value: selectedClass package.
			(b pane port: #classToSelect) value: selectedClass ].
	] on: $/ icon: MooseIcons mooseSearch entitled: 'Search class'
! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 19:30'!
detailsIn: a
	| accumulator |
	accumulator := GLMAccumulator new.
	accumulator show: [ :another | 
		another title: [ :package :class | class name ].
		self methodsIn: another ].
	a custom: accumulator! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 13:30'!
implementorsIn: a
	a list
		title: 'Implementors';
		display: [ :method | (self systemNavigation allImplementorsOf: method selector) ];
		selectionPopulate: #focusOnMethod
			on: $f
			entitled: 'Jump there'
			with: [ :list | list selection ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer ! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 19:14'!
methodSourceIn: another
	(another text)
		title: 'Source';
		display: [ :method | method getSource ]! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 19:30'!
methodsIn: a
	| expander |
	expander := GLMExpander new.
	expander display: [ :package :class | class methods ].
	expander
		show: [ :another | 
			another title: [ :method | method selector ].
			self methodSourceIn: another.
			self sendersIn: another.
			self implementorsIn: another ].
	a custom: expander! !

!GTCoder methodsFor: 'private' stamp: 'TudorGirba 1/8/2011 03:21'!
sendersIn: a
	a list
		title: 'Senders';
		display: [ :method | self systemNavigation allSendersOf: method selector];
		selectionPopulate: #focusOnMethod
			on: $j
			entitled: 'Jump there'
			with: [ :list | list selection ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

GLMGlobalBrowserTemplate subclass: #GTClassicBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

GTClassicBrowser class
	instanceVariableNames: 'announcer'!

!GTClassicBrowser commentStamp: '<historical>' prior: 0!
self openOn: Smalltalk organization.!

GTClassicBrowser class
	instanceVariableNames: 'announcer'!

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/14/2010 01:08'!
browserActionsIn: b
	"just for test"
	b act: [ 
		(b pane port: #classCategoryToSelect) value: (Smalltalk organization categoriesMatching: 'RPackage*') first ] entitled: 'Find'.
! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/14/2010 01:08'!
buildBrowser
	browser := GLMTabulator new.
	self browserActionsIn: browser.
	browser
		row: [:row | row column: #classCats; column: #classes; column: #categories; column: #methods ];
		row: #sourceCode.
	browser transmit to: #classCats; andShow: [ :a | self classCategoriesIn: a ].
	browser transmit to: #classes; from: #classCats; andShow: [ :a | self classesIn: a ].
	browser transmit to: #categories; from: #classes; andShow: [ :a | self categoriesIn: a ].
	browser transmit to: #methods; from: #classes; from: #categories; andShow: [ :a | self methodsIn: a ].
	browser transmit
		to: #sourceCode;
		from: #classes;
		from: #methods;
		from: #classCats;
		andShow: [ :a | self sourceCodeIn: a ].
	browser transmit
		fromOutside: #classCategoryToSelect;
		to: #classCats port: #selection.
	browser transmit 
		fromOutside: #classesToSelect;
		to: #classes.
	browser transmit 
		fromOutside: #methodsToSelect;
		to: #methods.
	^ browser! !

!GTClassicBrowser methodsFor: 'building' stamp: 'TudorGirba 11/26/2010 17:44'!
categoriesIn: a
	^ (a list)
		allowsDeselection;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :class | class organization categories ]! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classCategoriesIn: a
	^ (a list)
		display: [ :organization | organization categories asSortedCollection: [ :x :y | x < y ] ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classesHierarchyIn: a
	(a mondrian)
		painting: [ :view :package | 
					view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [ :name | Smalltalk classNamed: name ]).
					view edgesFrom: #superclass.
					view treeLayout ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		title: 'Hierarchy'! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classesIn: a
	self classesListIn: a.
	self classesHierarchyIn: a! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
classesListIn: a
	(a tree)
		shouldValidate: true;
		display: [ :classCat | (Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
		children: [ :each | each traitComposition traits ];
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		title: 'Class list'! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/13/2010 16:32'!
methodsIn: a
	(a list)
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :class :category | (class organization listAtCategoryNamed: category) asSortedCollection ].
	^ (a list)
		useExplicitNotNil;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		when: [ :class :category | class notNil and: [ category isNil ] ];
		display: [ :class :category | class selectors asSortedCollection ]! !

!GTClassicBrowser methodsFor: 'building' stamp: 'tg 11/6/2010 22:41'!
sourceCodeIn: a
	| lintBrowser |
	(a text)
		title: 'Method source';
		display: [ :class :method | class sourceCodeAt: method ];
		forSmalltalk: [ :class | class ].
	(a text)
		forSmalltalk;
		useExplicitNotNil;
		title: 'Class definition';
		display: [ :class | class definition ];
		when: [ :class | class notNil ].
	(a text)
		title: 'Class comment';
		display: [ :class | class comment ];
		useExplicitNotNil;
		when: [ :class | class notNil ].
	lintBrowser := GTLintBrowser new browser.
	lintBrowser
		allowNil;
		when: [ :clas :mth | clas notNil ].
	a custom: lintBrowser! !

GLMGlobalBrowserTemplate subclass: #GTCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTCodeBrowser commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTCodeBrowser classSide methodsFor: 'accessing' stamp: 'tg 1/20/2010 10:50'!
defaultEnvironment
	^ GTSTModel defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/16/2009 15:11'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous ST Browser'.
	self layout.
	self onPackages.
	self onClassesFromPackages.
	self onInstVarsFromClasses.
	self onMethodsFromClasses.
	self onMethodsFromInstVars.
	self onDetailsFromPackagesFromClassesFromMethods.
	browser sendTo: #outer->#focusOnMethod from: #details->#focusOnMethod with: [:m | m ].
	browser sendTo: #packages->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior glmPackage].
	browser sendTo: #classes->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior ].
	browser sendTo: #methods->#selection from: #outer->#focusOnMethod with: [:method | method ]! !

!GTCodeBrowser methodsFor: 'opening' stamp: 'tg 1/20/2010 10:51'!
entity 
	^ GTSTPackage rootPackagesOn: self class defaultEnvironment! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 09:36'!
layout
	browser
		column: #packages;
		column: [:c | c row: #classes; row: #instVars ];
		column: [:c | c row: #methods; row: #details] span: 3.! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/3/2010 14:13'!
onClassesFromPackages
	browser
		showOn: #classes; from: #packages;
		using: [
			browser tree
					when: [:package | package isCollection not];
					display: [:package | package allClasses];
					children: [ :each | each traits ];
					icon: [ :each | 
						each stBehavior theNonMetaClass browserIcon isNil ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ];
					format: [:class | class name];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer
		]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/3/2010 14:14'!
onDetailsFromPackagesFromClassesFromMethods
	browser
		showOn: #details; from: #classes; from: #methods; from: #packages; 
		using: [
			browser text
					forSmalltalk: [:class | class stBehavior ];
					title: 'Method';
					display: [:class :method | method sourceCode ].
			browser text
					forSmalltalk;
					title: 'Class';
					useExplicitNotNil;
					when: [:class :method | class notNil and: [method isNil]];
					display: [:class | class definition ].
			browser list
					title: 'References';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class references];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
			browser list
					title: 'Senders';
					display: [:class :method | method senders];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
			browser list
					title: 'Implementors';
					display: [:class :method | method implementors];
					format: [:each | each glmBehavior name, '>>', each name];
					populate: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ];
					updateOn: SystemAnnouncement from: SystemAnnouncer announcer.
		]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 11/3/2010 14:14'!
onInstVarsFromClasses
	browser showOn: #instVars; from: #classes; using: [ 
		browser list
				display: [ :class | class instVars ];
				tags: [ :each | 
					{ each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST'] } ];
				updateOn: SystemAnnouncement from: SystemAnnouncer announcer ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 1/17/2010 04:45'!
onMethodsFromClasses
	browser transmit to: #methods; from: #classes; andShow: [ :a | 
		a accordionArrangement.
		a list
				title: 'Instance';
				display: [ :class | class methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		a list
				title: 'Meta';
				display: [ :class | class metaSide methods ];
				tags: [ :each | 
					{each glmCategory name} ].
		 ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onMethodsFromInstVars
	browser showOn: #methods; from: #instVars; using: [ 
		browser list
				display: [ :var | var accessingMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GTCodeBrowser methodsFor: 'building' stamp: 'tg 10/17/2009 17:08'!
onPackages
	browser
		showOn: #packages;
		using: 
			[ browser tree
				children: [ :package | package subPackages ];
				format: [ :package | package name ];
				filterOn: [ :text :each | text match: each name ] ]! !

GLMGlobalBrowserTemplate subclass: #GTMetaceller
	instanceVariableNames: 'metacelloCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTMetaceller commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GTMetaceller methodsFor: 'building' stamp: 'tg 2/3/2010 16:35'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metacello Browser'.
	browser act: [:b | 
		Workspace new 
			contents: self helpText; 
			openLabel: 'Metaceller help' ] icon: MenuIcons smallHelpIcon entitled: 'Help'.
	browser column: #configs; column: #details span: 4.
	self toConfigsAndShow.
	self toDetailsFromConfigsAndShow.
	^ browser ! !

!GTMetaceller methodsFor: 'opening' stamp: 'tg 1/17/2010 01:38'!
entity 
	^ (Object subclasses select: [:each | (each class canUnderstand: #isMetacelloConfig) and: [
			each isMetacelloConfig ] ]) sort: [:a :b | a name < b name]! !

!GTMetaceller methodsFor: 'private' stamp: 'tg 2/3/2010 16:57'!
helpText
	^'Metaceller is a tool for browsing the Metacello configurations present in the image.

The Configurations tab lists all the projects from the ConfigurationOfXXX present in the image. Double clicking on an item spawns the configuration details.

The Versions tab lists all the versions defined in the configuration. The color coding shows:
- black = a possible baseline
- gray = not a possible baseline (probably due to packages no longer in the image)
- bold = the current version

The Imports tab shows how versions import from one another.

Upon selecting a version, the third pane shows the details of the specification of the version.

The Items tab shows the packages, groups and projects from the version. Each project can be expanded to display its items.

The color coding shows:
- blue = dirty packages 
- gray = packages that are not present in the image
- italics = groups

The "Newer in repository?" shows in red the packages that have newer versions published in the Monticello repository, thus indicating a possible need for update.'! !

!GTMetaceller methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 12:54'!
metacelloCache

	metacelloCache == nil ifTrue: [ metacelloCache := Dictionary new ].
	^metacelloCache! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 1/21/2010 12:32'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetaceller methodsFor: 'building' stamp: 'TudorGirba 11/27/2010 10:25'!
toConfigsAndShow
	browser transmit to: #configs; andShow: [ :a |
		| configList |
		a title: 'Configurations'.
		configList := a list
			format: [:configClass | | text label version |
				label := self shortNameOf: configClass.
				self useCacheDuring: [ version := configClass project currentVersion ].
				text := (self validCurrentVersion: version)
					ifTrue: [ (label, ' [', version versionString, ']') ]
					ifFalse: [ Text string: label attribute: TextColor gray].
				text ];
			act: [:list  | list selection browse ] entitled: 'Browse implementation';
			act: [:list  | list selection project inspect] entitled: 'Inspect'.
			Smalltalk at: #OBCmdMetacello ifPresent: [ :x |
				configList dynamicActionsOnSelection: [:list | 
					(GLMOBCommandAdaptor new 
						actionsFrom: (Smalltalk at: #OBCmdMetacello) subclasses 
						on: list selection 
						for: nil ) do: [:each | each category: 'OB Commands'] ] ] ]! !

!GTMetaceller methodsFor: 'building' stamp: 'tg 3/12/2010 15:49'!
toDetailsFromConfigsAndShow
	browser transmit from: #configs->#strongSelection; to: #details; andShowIfNone: [ :a |
		a custom: 
			(((GTMetacellerDetails new)
				master: self;
				yourself) browser noTitle )
		].
	browser transmit from: #configs; to: #details->#entityToSelect.
	browser transmit from: #details->#activeEntity; to: #configs->#selection.! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:33'!
useCacheDuring: aBlock

	"Use #respondsTo: until 1.0-beta.23 is in general use"
	(MetacelloPlatform current respondsTo: #useStackCacheDuring:defaultDictionary:)
		ifTrue: [
			MetacelloPlatform current
				useStackCacheDuring: [:dict | ^aBlock value ] 
				defaultDictionary: self metacelloCache ]
		ifFalse: [ ^aBlock value ]! !

!GTMetaceller methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:33'!
validCurrentVersion: version

	version isNil ifTrue: [ ^false ].
	(version respondsTo: #versionStatus) 
		ifTrue: [ "Use #respondsTo: until 1.0-beta.23 is in general use"
			^#(allLoadedToSpec loadedToSpec loadedMatchConstraints) includes: version versionStatus ].
	^true! !

GLMGlobalBrowserTemplate subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTPlayground commentStamp: 'TudorGirba 2/18/2011 09:21' prior: 0!
self open.


Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

!

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/3/2011 15:48'!
buildBrowser
	browser := GLMAccumulator new.
	browser title: 'Playground'.
	browser act: [:b | b entity: GTPlaygroundPage new] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Add'.
	browser show: [:a | 
		a title: [:page | page title].
		a text 
			forSmalltalk;
			display: [:page | page content ] ].
	^ browser! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/18/2011 09:23'!
entity 
	^ GTPlaygroundPage new content: ''; title: 'Page1'! !

GLMGlobalBrowserTemplate subclass: #GTProfStef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTProfStef commentStamp: 'tg 2/1/2010 15:40' prior: 0!
self openOn: SmalltalkSyntaxTutorial.!

!GTProfStef classSide methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:38'!
openOn: tutorial
	^ super openOn: (ProfStef goOn: tutorial viewedWith: GTProfStefNoView new)! !

!GTProfStef methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:41'!
buildBrowser
	browser := GLMFinder new.
	browser title: 'Prof Stef'.
	browser text
		forSmalltalk;
		display: [ :lesson | lesson lessonInstance lesson ];
		when: [:lesson | lesson isKindOf: TutorialNode];
		title: [:lesson | lesson lessonInstance title];
		selectionPopulate: #selection
			on: $o
			entitled: 'Open (o)'
			with: [ :text :entity | 
				| result |
				result := [Compiler 
					evaluate: text selectedText
					for: entity
					logged: false] on: Error do: [nil].
				(result isNil or: [result isKindOf: GTProfStefNoView]) ifTrue: [nil] ifFalse: [result] ];
		selectionAct: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)';
		populate: #selection icon: GLMUIThemeExtraIcons glamorousRight entitled: 'Next lesson'  with: [:text :lesson | ProfStef next ].
	^ browser! !

!GTProfStef methodsFor: 'opening' stamp: 'tg 2/1/2010 15:42'!
entity
	^ ProfStef goOn: SmalltalkSyntaxTutorial viewedWith: GTProfStefNoView new! !

GLMGlobalBrowserTemplate subclass: #GTProfStefEncyclopedia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTProfStefEncyclopedia commentStamp: 'tg 2/2/2010 23:33' prior: 0!
self open!

!GTProfStefEncyclopedia methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:45'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Prof Stef Encyclopedia'.
	browser column: #lessons; column: #details span: 4.
	browser transmit to: #lessons; andShow: [:a | 
		a list 
			title: 'Tutorials';
			send: [:class | ProfStef goOn: class viewedWith: GTProfStefNoView new ]
			"morphicSelectionAct: [:each | each selection browse ] entitled: 'Browse'"].
	browser transmit from: #lessons; to: #details; andShow: [:a | 
		a custom: GTProfStef new browser noTitle ].
	^ browser! !

!GTProfStefEncyclopedia methodsFor: 'opening' stamp: 'TudorGirba 1/31/2011 01:34'!
entity
	^ AbstractTutorial allSubclasses ! !

GLMGlobalBrowserTemplate subclass: #GTRemoteMetaceller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTRemoteMetaceller commentStamp: 'tg 2/2/2010 23:07' prior: 0!
self open!

!GTRemoteMetaceller methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:48'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Remote Metaceller'.
	browser column: #configs; column: #details.
	browser transmit to: #configs; andShow: [ :a | 
		a list 
			title: 'Remote configurations';
			format: #name;
			act: [:list | list selection version load ] entitled: 'Load configuration code' ].
	browser transmit to: #details; from: #configs; andShow: [ :a | 
		a list 
			title: 'Details';
			format: #selector;
			display: [:reference | reference version snapshot definitions select: [:each | 
					each isMethodDefinition and: [each classIsMeta not] ]];
			act: [:list | list selection inspect ] entitled: 'Inspect'].
	^ browser ! !

!GTRemoteMetaceller methodsFor: 'opening' stamp: 'tg 2/2/2010 23:06'!
entity 
	^ self remoteConfigurations! !

!GTRemoteMetaceller methodsFor: 'private' stamp: 'tg 2/2/2010 23:06'!
remoteConfigurations
	| gofer packages |
	gofer := Gofer new
		disablePackageCache;
		squeaksource: 'MetacelloRepository';
		yourself.
	packages := Set new.
	gofer allResolved do: [ :each |
		| name |
		name := each packageName.
		((name beginsWith: 'ConfigurationOf') and: [ (packages includes: name) not ]) ifTrue: [
			packages add: name.
			gofer package: name ] ].
	^ gofer resolved! !

GLMBrowserTemplate subclass: #GTChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTChaser commentStamp: 'TudorGirba 1/31/2011 00:27' prior: 0!
The Chaser unifies the navigation of both senders and implementors. Each pane represents either a method reference or a symbol, and it reveals its implementors and the senders in two different tabs.

self openOn: #methodsBrowser!

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 00:28'!
browse: method
	ToolSet 
		browse: method methodClass 
		selector: method selector! !

!GTChaser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 00:44'!
buildBrowser
	"self openOn: #browser"
	browser := GLMFinder new.
	browser title: [:each | 'Chasing Browser of #', each].
	browser show: [:a |
		a title: [ :each | self titleOf: each ].
		a custom: (self 
					methodsBrowserFor: #allSendersOf:
					title: 'Senders').
		a custom: (self 
					methodsBrowserFor: #allImplementorsOf:
					title: 'Implementors') ].
	^ browser! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 22:28'!
childrenOf: each
	^ (each isKindOf: MethodReference)
		ifTrue: [ each compiledMethod messages ]
		ifFalse: [ OrderedCollection new ] ! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 00:33'!
methodActionsFor: aListPresentation
	
	| actions |
	actions := OrderedCollection new.
	(aListPresentation selection isKindOf: MethodReference) ifTrue: [
		actions add: (GLMMorphicAction new 
						action: [:list | self browse: list selection]; 
						icon: GLMUIThemeExtraIcons glamorousBrowse;
						title: 'Browse';
						yourself) ].
	^ actions! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 00:46'!
methodsBrowserFor: aSymbol title: aString
	"this defines a simple browser that can displayed both senders and implementors.
	aSymbol is either #allSendersOf: or #allImplementorsOf:"
	| methodsBrowser |
	methodsBrowser := GLMTabulator new.
	methodsBrowser row: #methods; row: #source.
	methodsBrowser title: aString.
	methodsBrowser transmit to: #methods; andShow: [ :a | 
		a tree
			showOnly: 20;
			display: "[ :each | aBlock value: each ]"
					[:each | self systemNavigation perform: aSymbol with: ((each isKindOf: MethodReference) ifTrue: [each selector ] ifFalse: [ each ])];
			format: [:method | self titleOf: method ];
			children: [:each | self childrenOf: each];
			dynamicActionsOnSelection: [ :list | self methodActionsFor: list ] ].
	methodsBrowser transmit from: #methods; to: #source; andShow: [:some |
		some text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | reference sourceCode ];
			whenKindOf: MethodReference ].
	methodsBrowser transmit from: #methods; toOutsidePort: #selection.
	^ methodsBrowser! !

!GTChaser methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 22:22'!
titleOf: aSymbolOrReference
	^ (aSymbolOrReference isKindOf: MethodReference)
		ifTrue: [ aSymbolOrReference classSymbol , '>>' , aSymbolOrReference selector ]
		ifFalse: [ aSymbolOrReference ]! !

GLMBrowserTemplate subclass: #GTClassicChaser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTClassicChaser commentStamp: 'tg 1/15/2010 01:14' prior: 0!
self openOn: #browse!

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 19:07'!
buildBrowser
	"self openOn: #buildBrowser"

	| finder |
	finder := self finder.
	browser := GLMTabulator new.
	browser title: [ :each | 'Chasing ' , each asString ].
	browser
		row: #finder;
		row: #details.
	browser transmit 
		to: #finder;
		andShow: [:a | a custom: finder ].
	browser
		transmit to: #details;
		from: #finder;
		andShow: [:a | 
					(a text)
						forSmalltalk: [ :reference | reference actualClass ];
						display: [ :reference | [ reference compiledMethod getSource ] on: Error do: [ 'source not found' ] ];
						whenKindOf: MethodReference ].
	^ browser! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:13'!
finder
	| finder |
	finder := GLMFinder new.
	finder
		show: [ :a | 
			a title: [ :each | self titleOf: each ].
			self implementorsIn: a.
			self sendersIn: a ].
	^ finder! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:15'!
implementorsIn: a
	^ (a tree)
		title: 'Implementors';
		showOnly: 20;
		display: [ :each | 
					self systemNavigation
						allImplementorsOf:
							((each isKindOf: MethodReference)
								ifTrue: [ each selector ]
								ifFalse: [ each ]) ];
		format: [ :each | self titleOf: each ];
		selectionAct: [:each | each selection inspect ] on: $i entitled: 'Inspect';
		children: [ :each | 
					(each isKindOf: MethodReference)
						ifTrue: [ each compiledMethod messages ]
						ifFalse: [ OrderedCollection new ] ]! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:15'!
sendersIn: a
	^ (a tree)
		title: 'Senders';
		showOnly: 20;
		display: [ :each | 
					self systemNavigation
						allSendersOf:
							((each isKindOf: MethodReference)
								ifTrue: [ each selector ]
								ifFalse: [ each ]) ];
		format: [ :each | self titleOf: each ];
		selectionAct: [:each | each selection inspect ] on: $i entitled: 'Inspect';
		children: [ :each | 
					(each isKindOf: MethodReference)
						ifTrue: [ each compiledMethod messages ]
						ifFalse: [ OrderedCollection new ] ]! !

!GTClassicChaser methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 15:11'!
titleOf: aSymbolOrReference
	^ (aSymbolOrReference isKindOf: MethodReference)
		ifTrue: [ aSymbolOrReference classSymbol , '>>' , aSymbolOrReference selector ]
		ifFalse: [ aSymbolOrReference ]! !

GLMBrowserTemplate subclass: #GTClassicCoderCategoriesMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Coder'!

!GTClassicCoderCategoriesMethods methodsFor: 'building' stamp: 'TudorGirba 12/2/2010 20:11'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #categories; column: #methods.
	browser transmit
		toOutsidePort: #package;
		fromOutsidePort: #entity;
		transformed: [:packageAndClass | packageAndClass first ].
	browser transmit
		toOutsidePort: #class;
		fromOutsidePort: #entity;
		transformed: [:packageAndClass | packageAndClass last ].
	browser transmit
		to: #categories;
		fromOutsidePort: #class;
		andShow: [:a | self categoriesIn: a ].
	browser transmit 
		to: #methods; 
		fromOutsidePort: #package;
		fromOutsidePort: #class;
		from: #categories; 
		andShow: [ :a | self methodsIn: a ].
	browser transmit 
		toOutsidePort: #selectedCategory;
		from: #categories.
	browser transmit 
		toOutsidePort: #selectedMethod;
		from: #methods.
	^ browser! !

!GTClassicCoderCategoriesMethods methodsFor: 'private' stamp: 'TudorGirba 11/26/2010 21:21'!
categoriesIn: a
	a list
		title: 'Categories';
		allowsDeselection;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :class | class organization categories ]! !

!GTClassicCoderCategoriesMethods methodsFor: 'private' stamp: 'TudorGirba 12/2/2010 19:55'!
methodsIn: a 
	a list
		title: 'Methods';
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		display: [ :package :class :category | 
			(class methodDict values select: [:each | each category = category]) asSortedCollection: [:x :y | x selector < y selector ] ];
		format: [:each :package :class |
			((each isDefinedInPackage: package) or: [each isExtensionInPackage: package])
				ifTrue: [each selector asString]
				ifFalse: [Text string: each selector asString attribute: TextColor gray] ].
	a list
		title: 'Methods';
		useExplicitNotNil;
		updateOn: SystemAnnouncement from: SystemAnnouncer announcer;
		when: [ :package :class :category | class notNil and: [ category isNil ] ];
		display: [ :package :class :category | 
			class methodDict values asSortedCollection: [:x :y | x selector < y selector ] ];
		selectionAct: [:list :package :class | 
			(Array with: package with: class with: list selection) inspect  ] on: $/ entitled: 'Inspect';
		format: [:each :package :class |
			((each isDefinedInPackage: package) or: [each isExtensionInPackage: package])
				ifTrue: [each selector asString]
				ifFalse: [Text string: each selector asString attribute: TextColor gray] ]! !

GLMBrowserTemplate subclass: #GTClassicCoderInstanceAndMetaCategoriesMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Coder'!

!GTClassicCoderInstanceAndMetaCategoriesMethods methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/6/2011 19:47'!
buildBrowser
	"
	| browser |
	browser := self new browser.
	(browser pane port: #package) value: RPackageOrganizer default packages first.
	(browser pane port: #entity) value: RPackageOrganizer default packages first classes anyOne.
	browser open.
	browser inspect"
	browser := GLMStacker new.
	browser aPane: #instance; aPane: #meta.
	browser transmit 
		from: #outer->#package; 
		from: #outer->#entity; 
		when: [ :package :class | class notNil ];
		transformed: [:package :class | {package . class} ]; 
		to: #instance; 
		andShow: [ :a |
			a title: 'Instance'.
			a custom: GTClassicCoderCategoriesMethods new browser ].
	browser transmit 
		fromOutsidePort: #package; 
		from: #outer->#entity transformed: [:class | class ifNotNil: [class theMetaClass] ]; 
		when: [ :package :class | class notNil ];
		transformed: [:package :class | {package . class} ]; 
		to: #meta; andShow: [ :a |
			a title: 'Meta'.
			a custom: GTClassicCoderCategoriesMethods new browser ].
	browser transmit 
		toOutsidePort: #selectedMethod;
		from: #instance port: #selectedMethod.
	browser transmit 
		toOutsidePort: #selectedMethod;
		from: #meta port: #selectedMethod.
	^ browser! !

GLMBrowserTemplate subclass: #GTDiffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTDiffer commentStamp: 'tg 12/29/2009 16:46' prior: 0!
self openOn: Collection withAllSubclasses andOn: MooseGroup withAllSubclasses!

!GTDiffer classSide methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 16:34'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	^ self new openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses! !

!GTDiffer methodsFor: 'building' stamp: 'TudorGirba 1/30/2011 21:28'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous Diff Browser'.
	browser
		row: [:r | r column: #left; column: #right ];
		row: #diff.
	browser transmit toOutsidePort: #leftClasses; fromOutsidePort: #entity; transformed: [:assoc | assoc key].
	browser transmit toOutsidePort: #rightClasses; fromOutsidePort: #entity; transformed: [:assoc | assoc value].
	browser transmit to: #left; fromOutsidePort: #leftClasses; andShow: [:a | 
		(a custom: GTSimpleClassesMethodsBrowser new browser)
			title: 'Left' ].
	browser transmit to: #right; fromOutsidePort: #rightClasses; andShow: [:a | 
		(a custom: GTSimpleClassesMethodsBrowser new browser)
			title: 'Right' ].
	browser transmit to: #diff; 
		from: #left port: #selectedClass; from: #left port: #selectedMethod;
		from: #right port: #selectedClass; from: #right port: #selectedMethod;
		andShow: [:a | 
		a diff
			display: [:leftClass :leftMethod :rightClass :rightMethod | 
				Array with: (leftClass sourceCodeAt: leftMethod) with: (rightClass sourceCodeAt: rightMethod)
			]
		].
	^ browser! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:50'!
openOn: aCollectionOfClasses
	self browser openOn: aCollectionOfClasses andOn: aCollectionOfClasses! !

!GTDiffer methodsFor: 'opening' stamp: 'tg 12/29/2009 16:36'!
openOn: aCollectionOfClasses andOn: anotherCollectionOfClasses
	self browser openOn: aCollectionOfClasses -> anotherCollectionOfClasses! !

GLMBrowserTemplate subclass: #GTLintBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTLintBrowser commentStamp: 'tg 12/29/2009 03:55' prior: 0!
self openOn: GLMPresentation withAllSubclasses asOrderedCollection!

!GTLintBrowser methodsFor: 'building' stamp: 'tg 1/16/2010 22:35'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Lint Browser'.
	browser column: #groups; column: #rules; column: #results.
	browser transmit from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; to: #groups; andShow: [ :a |
 		a list
			display: [:dic | RBCompositeLintRule lintChecks rules];
			allowNil;
			format: #name ].
	browser showOn: #rules; from: #groups; using: [
		browser list
			display: [:group | group rules];
			format: #name ].
	browser transmit to: #results; from: #rules; from: #outer->#entity transformed: [:classOrCollection | classOrCollection isCollection ifFalse: [{ classOrCollection }] ifTrue: [ classOrCollection ]]; andShow: [ :a |
		a list
			display: [:rule :tuple | self getLintResult:
					(self runRule: rule forClasses: tuple) result] ].
			"tuple = {class. selector} from the browser. We select the class"
	browser sendToOutside: #faultyMethod from: #results->#selection.
	^ browser! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:22'!
getLintResult: anEnvironment

	| results stream |
	results := OrderedCollection new.
	anEnvironment classesAndSelectorsDo: [:class :sel | results add: sel].
	^ results! !

!GTLintBrowser methodsFor: 'private' stamp: 'tg 1/16/2010 22:28'!
runRule: aRule forClasses: aClassesCollection

	| environment |
	environment := BrowserEnvironment new forClasses: aClassesCollection.
	^ SmalllintChecker runRule: aRule onEnvironment: environment! !

GLMBrowserTemplate subclass: #GTMessageTallyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTMessageTallyBrowser commentStamp: 'TudorGirba 1/31/2011 00:50' prior: 0!
This browser shows the result of applying method tally to a given computation block.

For example:

self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:00'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Message Tally'.
	browser
		column: #messages;
		column: #details.
	(browser transmit)
		to: #messages;
		andShow: [ :a | self messagesIn: a ].
	(browser transmit)
		to: #details;
		from: #messages;
		andShow: [ :a | self sourceCodeIn: a ].
	^ browser! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:13'!
messagesIn: a
	^ (a tree)
		title: 'Message tree';
		children: [ :each | each sonsOver: -1 ];
		morphicSelectionAct: [ :list | GTUtils browseMethod: list selection method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		format: [ :each | Text fromString: (GTUtils printCompiledMethod: each method) , ' (' , each tally printString , ')']! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'tg 12/29/2009 03:36'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

!GTMessageTallyBrowser methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 01:10'!
sourceCodeIn: a
	^ (a text)
		title: [ :each | GTUtils printCompiledMethod: each method ];
		morphicAct: [ :text :each | GTUtils browseMethod: each method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		forSmalltalk: [ :each | each method methodClass ];
		display: [ :each | each method methodClass sourceCodeAt: each method selector ifAbsent: [ 'unknown' ] ]! !

GLMBrowserTemplate subclass: #GTMessageTallyFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTMessageTallyFinder commentStamp: 'tg 12/29/2009 04:07' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:08'!
buildBrowser
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'Messages';
		display: [:each | each sonsOver: -1];
		format: [:each | each printString, ' (', each tally printString, ')'].
	browser := GLMTabulator new.
	browser row: #messages; row: #source.
	browser showOn: #messages; using: [browser custom: finder].
	browser showOn: #source; from: #messages; using: [
		browser text
			title: 'Source';
			forSmalltalk: [:each | each method methodClass];			
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GTMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:07'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GTMetacellerDetails
	instanceVariableNames: 'master'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Prototypes'!

!GTMetacellerDetails commentStamp: 'tg 2/1/2010 22:36' prior: 0!
self openOn: ConfigurationOfGlamour!

!GTMetacellerDetails methodsFor: 'building' stamp: 'tg 2/8/2010 23:00'!
buildBrowser
	| innerBrowser |
	browser := GLMAccumulator new.
	browser title: 'Metaceller Configuration Browser'.
	innerBrowser := GLMTabulator new.
	innerBrowser column: #versions; column: #packages span: 2.
	self toPackagesFromVersionsAndShow: innerBrowser.
	self toVersionsAndShow: innerBrowser.
	browser show: [ :a |
		a title: 	[:config | self shortNameOf: config ].
		a custom: innerBrowser ].
	browser transmit toOutside: #entity; fromOutside: #strongSelection.
! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'DaleHenrichs 2/8/2010 14:16'!
goferForVersion: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	version packages do: [:each | 
		(each isKindOf: MetacelloPackageSpec) ifTrue: [ g package: each name]].
	^ g! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 10/28/2010 14:23'!
labelOfItemSpec: packageSpec

	| label text |
	label := packageSpec name.
	(packageSpec isKindOf: MetacelloPackageSpec) ifTrue: [label := packageSpec file].
	(packageSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [label := packageSpec name, ' ', packageSpec versionString].
	
	text := ((packageSpec isKindOf: MetacelloPackageSpec) and: [
		self packageSpecNeedsSaving: packageSpec])
			ifTrue: [Text string: label attribute: TextColor blue] 
			ifFalse: [ 
				label
				"Text 
					string: label
					attribute: ((self master useCacheDuring: [ packageSpec isLoaded ]) 
					ifTrue: [TextColor black] 
					ifFalse: [TextColor gray])"].
	(packageSpec isKindOf: MetacelloGroupSpec) ifTrue: [ 
		text addAttribute: TextEmphasis italic from: 1 to: text size ].
	^ text! !

!GTMetacellerDetails methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 14:26'!
master
	^ master! !

!GTMetacellerDetails methodsFor: 'accessing' stamp: 'DaleHenrichs 2/8/2010 14:26'!
master: anObject
	master := anObject! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packageSpec: packageSpec hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: packageSpec name.
	^ g resolved first name ~= packageSpec currentVersionInfo name! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packageSpecNeedsSaving: aPackageSpec
	| copy |
	copy := aPackageSpec workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
packagesAndGroupsOf: version
	| packageMap |
	packageMap := Dictionary new.
	version groups do: [:eachGroup |
		(version packagesForSpecNamed: eachGroup name) do: [:eachPackage |
			packageMap at: eachPackage ifAbsentPut: [OrderedCollection new].
			(packageMap at: eachPackage) add: eachGroup name ] ].
	^ packageMap! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:35'!
shortNameOf: config
	"self new shortNameOf: ConfigurationOfAlien"
	^ ((config name beginsWith: 'ConfigurationOf') 
		ifTrue: [config name copyFrom: 'ConfigurationOf' size + 1 to: config name size ] 
		ifFalse: [config name]) asString! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:28'!
spawnNewVersionFrom: sourceVersion in: aSmalltalkClass
	| vn targetVersionString selector |
	vn := sourceVersion versionString asMetacelloVersionNumber copy incrementMinorVersionNumber.
	targetVersionString := OBTextRequest prompt: 'Enter the target version number (source: ', sourceVersion versionString, ').' template: vn printString.
	selector := OBTextRequest prompt: 'Enter the new method selector' template: ('version', (targetVersionString copyWithout: $.) copyWithout: $-), ':'.
	selector numArgs ~~ 1 ifTrue: [ ^ self error: 'Selector must take a single argument: ', selector ].
	MetacelloVersionConstructor 
		spawnPackageMethodIn: aSmalltalkClass new 
		named: selector asSymbol
		sourceVersion: sourceVersion versionString
		targetVersion: targetVersionString ! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
tagsOf: packageSpec in: version
	^ (self packagesAndGroupsOf: version) at: packageSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'tg 2/16/2010 12:53'!
toPackagesFromVersionsAndShow: innerBrowser
	innerBrowser transmit to: #packages; from: #versions; andShow: [ :a |
		a title: [:version | version name ].
		a tree
			title: 'Items';
			display: [:version | version spec packages packageSpecsInLoadOrder];
			format: [:packageSpec | 
				self labelOfItemSpec: packageSpec] ;
			children: [:spec | 
				(spec isKindOf: MetacelloProjectReferenceSpec) 
					ifTrue: [ spec projectReference version spec packages packageSpecsInLoadOrder ]
					ifFalse: [	#() ]
				];
			tags: [:packageSpec :version | 
				self tagsOf: packageSpec in: version  ]; 
			act: [:list  | list selection inspect] entitled: 'Inspect';
			act: [:list :version | version load: list selection name ] entitled: 'Load'.
 		a mondrian
			title: 'Dependencies';
			painting: [:view :version | self viewDependenciesOf: version on: view].
		a text 
			title: 'Script';
			forSmalltalk;
			display: [:version |
				version spec printString ].
		a list
			title: 'Newer in repository?';
			display: [:version | version spec packages packageSpecsInLoadOrder ];
			format: [:packageSpec :version | ((packageSpec isKindOf: MetacelloPackageSpec) and: [
					self  packageSpec: packageSpec hasNewerVersionsFrom: version])
				ifTrue: [Text string: packageSpec name attribute: TextColor red] ifFalse: [packageSpec name]];
			act: [:list  | list selection inspect] entitled: 'Inspect'
	].
	innerBrowser transmit 
		toOutside: #strongSelection; from: #packages->#strongSelection; 
		when: [:selection | selection isKindOf: MetacelloProjectReferenceSpec ]; 
		transformed: [:selection | selection projectReference projectClass ]! !

!GTMetacellerDetails methodsFor: 'building' stamp: 'tg 2/16/2010 12:37'!
toVersionsAndShow: innerBrowser
	innerBrowser transmit to: #versions; andShow: [ :a |
		a list
			title: 'Versions';
			display: [:config | config project versions reverse ];
			format: [:each :config | | text |
				text := ([each isPossibleBaseline not] on: Error do: [true])
					ifTrue: [Text string: each versionNumber asString attribute: TextColor gray] 
					ifFalse: [each versionNumber asString asText].
				(self master useCacheDuring: [ config project currentVersion ]) = each ifTrue: [ text allBold ].
				text ];
			act: [:list :config | 
				self spawnNewVersionFrom: list selection in: config.
				list update.
				] entitled: 'Spawn new version';
			act: [:list | 
				(self goferForVersion: list selection) browseRemoteChanges ] entitled: 'Browse remote changes';
			act: [:list  | list selection inspect] entitled: 'Inspect'.
		a mondrian
			title: 'Imports';
			painting: [:view :config | self viewVersionMapOf: config on: view]]! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
viewDependenciesOf: version on: view
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view shape curvedLine.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout! !

!GTMetacellerDetails methodsFor: 'private' stamp: 'tg 2/1/2010 22:29'!
viewVersionMapOf: configClass on: view

	| prag1 prag2 nodes edges version imported |
	prag1 := Pragma allNamed: #version:imports: in: configClass.
	prag2 := Pragma allNamed: #version: in: configClass.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	prag2 do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)) ].
	prag1 do: [:prag | 
		version := nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [configClass project version: eachImportPrag].
			edges add: version -> imported.
			]
		].
	view shape label text: [:each | each versionNumber printString].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMBrowserTemplate subclass: #GTObjectFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTObjectFinder commentStamp: 'TudorGirba 1/30/2011 22:06' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One feature particular feature is that one can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

self openOn: MooseModel root.

self new methodsBrowser openOn: 1!

!GTObjectFinder methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 11:43'!
buildBrowser
	browser := GLMFinder new.
	browser title: [:anObject | (self printObjectAsAnItem: anObject), ' - Object Finder'].
	browser show: [ :a | 
			a title: [ :anObject | self printObjectAsAnItem: anObject ].
			a morphicAct: [:composite | composite entity browse] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'.
			self variablesIn: a.
			self itemsIn: a.
			a custom: self methodsBrowser.
			self evaluatorIn: a ].
	^ browser! !

!GTObjectFinder methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 14:40'!
evaluatorIn: a
	^ (a text)
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		selectionPopulate: #selection
			on: $o
			entitled: 'Open (o)'
			with: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ];
		selectionAct: [ :text :entity | (Compiler evaluate: text selectedText for: entity logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'! !

!GTObjectFinder methodsFor: 'building' stamp: 'TudorGirba 1/12/2011 14:49'!
itemsIn: a
	(a list)
		title: [ :anObject | anObject size asString , ' items' ];
		when: [ :each | each isCollection ];
		icon: [ :each |  OBMorphicIcons iconNamed: each class theNonMetaClass browserIcon ];
		showOnly: 20! !

!GTObjectFinder methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 22:08'!
methodsBrowser
	| methodsBrowser |
	methodsBrowser := GLMTabulator new.
	methodsBrowser title: 'Methods'.
	methodsBrowser row: #methods; row: #source.
	methodsBrowser transmit to: #methods; andShow: [:a | 
		a list 
			display: [:object | object class methods ];
			format: [:method | method selector];
			selectionPopulate: #evaluatedObject on: $o entitled: 'Evaluate and open' with: [:list :object | object perform: list selection selector ] ].
	methodsBrowser transmit to: #source; from: #methods; andShow: [:a | 
		a text 
			display: [:method | method getSource ];
			forSmalltalk: [:method | method methodClass ]].
	methodsBrowser transmit toOutside: #selection; from: #methods port: #evaluatedObject.
	^ methodsBrowser ! !

!GTObjectFinder methodsFor: 'private' stamp: 'tg 12/29/2009 03:43'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

!GTObjectFinder methodsFor: 'building' stamp: 'TudorGirba 1/31/2011 12:46'!
variablesIn: a
	(a list)
		title: 'Variables';
		display: [ :anObject | 
			OrderedCollection new 
				add: ('self' -> anObject);
				addAll: (anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv)]);
				yourself
			 ];
		format: [ :assoc | assoc key asString , ' : ' , (assoc value printString copyFrom: 1 to: ((50 min: assoc value printString size) max: 0)) ];
		icon: [ :each |  OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ];
		send: #value! !

GLMBrowserTemplate subclass: #GTSimpleClassesMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTSimpleClassesMethodsBrowser commentStamp: 'TudorGirba 1/30/2011 21:27' prior: 0!
This is a simple browser showing a list of classes and their methods. It is meant to be used inside other browsers.

self openOn: Collection withAllSubclasses!

!GTSimpleClassesMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 1/30/2011 21:10'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #classes; column: #methods.
	browser showOn: #classes; using: [
		browser list
			display: [:classes | classes asOrderedCollection sorted: [:a :b | a name < b name] ]].
	browser showOn: #methods; from: #classes; using: [
		browser list
			display: [:cls | cls selectors asOrderedCollection sorted: [:a :b | a < b]]].
	browser sendToOutside: #selectedClass from: #classes.
	browser sendToOutside: #selectedMethod from: #methods.
	^ browser! !

Object subclass: #GTPlaygroundPage
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content
	^ content! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content: anObject
	content := anObject! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:47'!
initialize
	content := 'self'! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title
	^ title! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title: anObject
	title := anObject! !

Object subclass: #GTProfStefNoView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools'!

!GTProfStefNoView commentStamp: 'TudorGirba 1/31/2011 01:37' prior: 0!
This is a utility class to circumvent the design of ProfStef.!

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
close! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
open
! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:05'!
showLesson: aLesson
	^ aLesson lesson! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/1/2010 15:02'!
showLesson: aLesson withTitle: aString
	^ aLesson! !

!GTProfStefNoView methodsFor: 'as yet unclassified' stamp: 'tg 2/7/2010 19:05'!
showTutorialNode: aTutorialNode
	^ aTutorialNode ! !

Object subclass: #GTUtils
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTUtils classSide methodsFor: 'utils' stamp: 'TudorGirba 1/31/2011 00:55'!
browseMethod: aCompiledMethod
	ToolSet 
		browse: aCompiledMethod methodClass 
		selector: aCompiledMethod selector! !

!GTUtils classSide methodsFor: 'utils' stamp: 'TudorGirba 1/31/2011 01:09'!
printCompiledMethod: method
	^ String streamContents: [:stream | stream print: method methodClass; nextPutAll: '>>'; nextPutAll: method selector storeString]! !

Object subclass: #GTVisualizations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Tools-Utils'!

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'tg 5/8/2010 18:17'!
viewPragmaConstellation
	"self new viewPragmaConstellation"
	| view |
	view := MOViewRenderer new.
	self viewPragmaConstellationOn: view.
	view openWithStatusbar! !

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'tg 5/8/2010 21:39'!
viewPragmaConstellationOf: pragmas on: view
	
	| pragmaTypes |
	pragmaTypes := pragmas groupedBy: #keyword.
	view shape ellipse fillColor: Color lightGray; withoutBorder.
	view nodes: (pragmas collect: [:each | each method methodClass]).
	view shape rectangle 
		text: #name;
		fillColor: Color gray;
		fontColor: Color white;
		linearFontSize: [:each | 
			(pragmaTypes at: each) size ] within: pragmaTypes keys;
		withoutBorder.
	view nodes: pragmaTypes keys.
	view shape line color: Color veryVeryLightGray; width: 3.
	view edges: pragmas from: [:each | each method methodClass] to: #keyword.
	view layout: MOGraphVizLayout new.
! !

!GTVisualizations methodsFor: 'as yet unclassified' stamp: 'tg 5/8/2010 18:17'!
viewPragmaConstellationOn: view
	
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	self viewPragmaConstellationOf: pragmas on: view! !
